package com.example.emf.validation.ocl;


import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.impl.EPackageRegistryImpl;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.ocl.pivot.uml.UMLStandaloneSetup;
import org.eclipse.ocl.pivot.utilities.OCL;
import org.eclipse.ocl.xtext.completeocl.CompleteOCLStandaloneSetup;
import org.eclipse.ocl.xtext.completeocl.validation.CompleteOCLEObjectValidator;

import bookModel.BookModelPackage;

public class CompleteOCLValidator {
	public CompleteOCLValidator(){
		UMLStandaloneSetup.init();
		CompleteOCLStandaloneSetup.doSetup();
	}
	
	private OCL createOcl(){
		// Copied from org.eclipse.ocl.examples.test.xtext.PivotDocumentationExamples.java

//		// Create an EPackage.Registry for just the BookModelPackage
//		EPackage.Registry registry = new EPackageRegistryImpl();
//		registry.put(BookModelPackage.eNS_URI, BookModelPackage.eINSTANCE);
//		
//		// Create an OCL that creates a ResourceSet using the minimal EPackage.Registry
//		OCL ocl = OCL.newInstance(registry);
		
		OCL ocl = OCL.newInstance(OCL.CLASS_PATH); // Get all resources on the classpath
		
		return ocl;
	}
	
	public int validateWithCompleteOCL(EObject objToValidate, URI completeOclUri){
		OCL ocl = this.createOcl();
		
		// Copied from org.eclipse.ocl.examples.test.xtext.PivotDocumentationExamples.java

		// Register an extended EValidator for the Complete OCL document constraints
		CompleteOCLEObjectValidator myValidator = new CompleteOCLEObjectValidator(
			BookModelPackage.eINSTANCE, completeOclUri, ocl.getEnvironmentFactory());
		EValidator.Registry.INSTANCE.put(BookModelPackage.eINSTANCE, myValidator);
		
		// Validate the object
		Diagnostician diagnostician = Diagnostician.INSTANCE;
		Diagnostic diagnostics = diagnostician.validate(objToValidate);
		
		// Print the diagnostics
		if (diagnostics.getSeverity() != Diagnostic.OK) {
			System.out.println("Validation result: "+diagnostics.getMessage());
		}
		else{
			System.out.println("Validation completed without errors.");
		}
		
		return diagnostics.getSeverity();
	}
}
