import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.junit.Before;
import org.junit.Test;

import com.example.emf.validation.ocl.CompleteOCLValidator;

import bookModel.Book;
import bookModel.BookModelFactory;
import bookModel.Shelf;

public class CompleteOCLTester {
	private Shelf shelfToTest = null;

	@Before
	public void setUp() throws Exception {
		Shelf shelf = BookModelFactory.eINSTANCE.createShelf();
		Book book01 = BookModelFactory.eINSTANCE.createBook();
		
		book01.setTitle("The Lord Of The Rings");
		shelf.setLocation("Basement");
		shelf.getBooks().add(book01);
		
		this.shelfToTest = shelf;
	}

	@Test
	public void testValidateWithCompleteOCL() throws IOException {
		CompleteOCLValidator validator = new CompleteOCLValidator();
		
		File completeOclFile 
			= new File("ocl/bookvalidation.ocl");
		if (!completeOclFile.exists()){
			throw new IOException("Complete OCL file not found!");
		}
		URI completeOclUri = URI.createFileURI(completeOclFile.getAbsolutePath());
		
		int severity = validator.validateWithCompleteOCL(this.shelfToTest, completeOclUri);
		
		assertNotEquals(severity, 0);
	}

}
